<?php
/**
 *
 * @package page
 * @copyright Copyright 2003-2005 Zen Cart Development Team
 * @copyright Portions Copyright 2003 osCommerce
 * @license http://www.zen-cart.com/license/2_0.txt GNU Public License V2.0
 * @version $Id: J_Schilz for Integrated COWOA - 2007
 * @version $Id: JT of GTI Custom Modified for Integrated COWOA 02-July-2010
 * @version $Id: Integrated COWOA v2.7
 */
 // abuse deterrents like spam from tell-a-freand
define('ORDER_STATUS_THROTTLE_TIMER', 90); // can't do another more frequently than this many seconds
// This should be first line of the script:
$zco_notifier->notify('NOTIFY_HEADER_START_ORDER_STATUS');

//log on users should use the account history page
if ($_SESSION['customer_id']) zen_redirect(zen_href_link(FILENAME_ACCOUNT_HISTORY, '', 'SSL'));

require(DIR_WS_MODULES . zen_get_module_directory('require_languages.php'));

if (isset($_GET['action']) && ($_GET['action'] == 'status')) {
$error = false;

  if (isset($_SESSION['order_status_timeout']) && ((int)$_SESSION['order_status_timeout'] + ORDER_STATUS_THROTTLE_TIMER) > time()) $error = true;
  
$orderID = zen_db_prepare_input($_POST['order_id']);
$query_email_address = zen_db_prepare_input($_POST['query_email_address']); 
$antiSpam = isset($_POST['should_be_empty']) ? zen_db_prepare_input($_POST['should_be_empty']) : '';
 
if(!isset($orderID) || (isset($orderID) && !is_numeric($orderID))) {
  $error = true;
  $messageStack->add('order_status', ERROR_INVALID_ORDER);
 }
 
if(!isset($query_email_address) || zen_validate_email($query_email_address) == false) {
  $error = true;
  $messageStack->add('order_status', ERROR_INVALID_EMAIL);
}

if(!$error) { //check to see if this address is in our database
 $customeremail = $db->Execute("SELECT DISTINCT customers_email_address FROM " . TABLE_CUSTOMERS . " WHERE customers_email_address = '" . $query_email_address . "'");
 if ($customeremail->RecordCount() <= 0) {
 $error = true ;
 $messageStack->add('order_status', ERROR_INVALID_EMAIL);
 }
}

if($antiSpam != '') $error = true ;
 
if($error == false)
{

  $customer_info_query = "SELECT customers_email_address, customers_id, orders_id 
                          FROM   " . TABLE_ORDERS . "
                          WHERE  orders_id = :ordersID";

  $customer_info_query = $db->bindVars($customer_info_query, ':ordersID', $orderID, 'integer');
  $customer_info = $db->Execute($customer_info_query);
  
if($customer_info->fields['orders_id'] != $orderID) {
  $messageStack->add('order_status', ERROR_NO_MATCH);
}else{

    $statuses_query = "SELECT os.orders_status_name, osh.date_added, osh.comments
                       FROM   " . TABLE_ORDERS_STATUS . " os, " . TABLE_ORDERS_STATUS_HISTORY . " osh
                       WHERE      osh.orders_id = :ordersID
                       AND        osh.orders_status_id = os.orders_status_id
                       AND        os.language_id = :languagesID
                       AND        osh.customer_notified >= 0
                       ORDER BY   osh.date_added";

    $statuses_query = $db->bindVars($statuses_query, ':ordersID', $orderID, 'integer');
    $statuses_query = $db->bindVars($statuses_query, ':languagesID', $_SESSION['languages_id'], 'integer');
    $statuses = $db->Execute($statuses_query);

    while (!$statuses->EOF) {

      $statusArray[] = array('date_added'=>$statuses->fields['date_added'],
      'orders_status_name'=>$statuses->fields['orders_status_name'],
      'comments'=>$statuses->fields['comments']);

      $statuses->MoveNext();
    }

    require(DIR_WS_CLASSES . 'order.php');
    $order = new order($orderID);
    
   $_SESSION['order_status_timeout'] = time(); //set the timer
   
  } //order_id matched
 } //error is true
} //eof action

// This should be last line of the script:
$zco_notifier->notify('NOTIFY_HEADER_END_ORDER_STATUS');
// eof
